#include<bits/stdc++.h>
using namespace std;
int n, q, dp[100001];
vector<int> e[100001];
int dfs(int a){
    if(dp[a] != 0)return dp[a];
    int ans = 0;
    for(int i = 0; i < e[a].size(); i++){
        ans += dfs(e[a][i]);
    }
    dp[a] = ans + 1;
    return ans + 1;
}

int main(){

    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cin >> n;
    for(int i = 0; i < n - 1; i++){
        int u, v; cin >> u >> v;
        e[u].push_back(v);
    }
    cin >> q;
    for(int i = 0; i < q; i++){
        int in; cin >> in;
        //cout << " ";
        cout << dfs(in) - 1 << endl;
    }

    return 0;
}
